%% Copyright 2014 Keith Clark, Peter Robinson
%%
%% Licensed under the Apache License, Version 2.0 (the "License");
%% you may not use this file except in compliance with the License.
%% You may obtain a copy of the License at
%%
%%     http://www.apache.org/licenses/LICENSE-2.0
%%
%% Unless required by applicable law or agreed to in writing, software
%% distributed under the License is distributed on an "AS IS" BASIS,
%% WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
%% See the License for the specific language governing permissions and
%% limitations under the License.


main([File]) :-
    op(0, xfx, in),
    (
      qconsult(File)
    ->
      (
        current_predicate('qmain'/1)
      ->
        !
      ;
        writeL(stderr, [nl_, "Error: No definition of qmain/1", nl_]),
        halt(1)
      ),
      atom_concat(File, '.ql', QlFile),
      open(QlFile, write, S),
      set_std_stream(1, S),
      dump2file,
      reset_std_stream(1)
    ;
      writeL(stderr, [nl_, File, " not translated", nl_, nl_]), 
      halt(1)
    ).

dump2file :-
    findall(F/N, ('$asserted_file_info'(_, Info), functor(Info, F, N)),
            AllInfo),
    sort(AllInfo, SortedInfo),
    dump2file_aux(SortedInfo).

dump2file_aux([]).
dump2file_aux([(F/N)|Rest]) :-
    dump2file_aux1(F, N),
    dump2file_aux(Rest).


dump2file_aux1('$goal', 1) :- !.
dump2file_aux1('$runtime_goal', 1) :- !.

dump2file_aux1('$state_belief', 1) :-
    '$asserted_file_info'(_, '$state_belief'(B)),
    writeq('?-'(remember('$state_belief'(B)))),write('.\n'),
    write('?-'(remember((B)))),write('.\n'),
    fail.
dump2file_aux1('$state_belief', 1) :- !.
dump2file_aux1(qmain, 1) :-
    clause(qmain(Args), Body),
    portray_clause((main(Args1) :- map('$atom2string', Args1, Args), Body)),
    fail.
dump2file_aux1(qmain, 1) :- !.
dump2file_aux1(F, N) :-
    listing(F/N).

